# KFR 6 Documentation

## Getting started

* [What's new in KFR 6](whatsnew6.md)
* [Installation](installation.md)
* [Basics](basics.md)
* [Expressions](expressions.md)
* [C API](capi.md)
* [Upgrade to KFR 6](upgrade6.md)

## Guides

### DSP
* [How to apply a FIR filter](fir.md)
* [How to apply a Biquad filter](bq.md)
* [How to do Sample Rate Conversion](src.md)
* [How to apply Convolution Reverb](conv_reverb.md)
* [How to measure loudness according to EBU R 128](ebur128.md)
* [How to convert sample type](conversion.md)
* [How to normalize audio](normalize.md)
* [How to mix stereo channels](convert_stereo.md)
* [FIR filters code & examples](fir_gallery.md)
* [IIR filters code & examples](iir_gallery.md)
* [Biquad filters code & examples](bq_gallery.md)
* [Sample Rate Converter code & examples](src_gallery.md)
* [Window functions code & examples](window_gallery.md)
* [Convolution filter details](convolution.md)

### FFT
* [How to apply Fast Fourier Transform](dft.md)
* [More about FFT/DFT](dft2.md)
* [DFT data layout](dft_format.md)

### I/O
* [How to read WAV file](read_audio.md)
* [File types support](file_support.md)
* [How to plot filter impulse response](plot.md)

## Function reference

* [Function reference](auto/refindex.md)

## KFR 5

For KFR 5 documentation, see https://kfr.dev/docs/v5
